#!/usr/bin/python3

import socket
from threading import Thread
from threading import Lock
from time import sleep

CLUNET_DEVICE = "/dev/clunet"
CLUNET_PORT = 10009
CLUNET_PASSWORD = "kDfQFGE3gL"

clients = []

class ClunetClientConnection:
    def __init__(self, socket):
        self.socket = socket
        self.buffer = []
        self.lock = Lock()
        self.c_thread = Thread(target = self.client_thread, daemon = True)
        self.s_thread = Thread(target = self.sending_thread, daemon = True)
        self.c_thread.start()
        self.s_thread.start()

    def client_thread(self):
        try:
            self.socket.send("Password:\n".encode('ascii'))
            password = ""
            while self.socket:
                data = self.socket.recv(1)
                if len(data) == 0:
                    return
                if data[0] != 10 and data[0] != 13:
                    password += data.decode('ascii')
                else:
                    if password == CLUNET_PASSWORD:
                        self.socket.send("Auth OK\n".encode('ascii'))
                        break
                    else:
                        sleep(3) # Bruteforce protection
                        self.socket.send("Access denied\nPassword:\n".encode('ascii'))
                        password = ""
            clients.append(self)
            with open(CLUNET_DEVICE, "w") as clunet_writer:
                while self.socket:
                    data = self.socket.recv(1024)
                    if len(data) == 0:
                        return
                    l = data.decode('ascii')
                    try:
                        print(l, file=clunet_writer, end='', flush=True)
                    except Exception as e:
                        print("Write error:", e)
                    
        except Exception as e:
            print("Error:", e)
        finally:
            if self in clients: 
                clients.remove(self)
            if (self.socket != None):
                self.socket.close()
            self.socket = None
            
    def send(self, data):
        with self.lock:
            self.buffer.extend(list(data))
        
    def sending_thread(self):
        while self.socket:
            try:
                if len(self.buffer) > 0:
                    with self.lock:
                        l = self.socket.send(bytes(self.buffer))
                        if l > 0:
                            self.buffer = self.buffer[l:]
                else:
                    sleep(0.01)
            except Exception as e:
                print("Error:", e)
                if self in clients: 
                    clients.remove(self)
                if (self.socket != None):
                    self.socket.close()
                self.socket = None

def port_listener():
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    try:
        s.bind(("0.0.0.0", CLUNET_PORT))
        s.listen(10)
        print("Listening post", CLUNET_PORT)
        while s:
            conn, addr = s.accept()
            print('Connected:', addr)
            ClunetClientConnection(conn)
    except Exception as e:
        print("Error:", e)
    finally:
        s.close()

try:
    Thread(target = port_listener, daemon = True).start()
    with open(CLUNET_DEVICE, "r") as clunet_reader:
        while True:
            l = clunet_reader.readline()
            for c in clients:
                c.send(l.encode('ascii'))
except Exception as e:
    print("Error:", e)
    while True:
        pass
