﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Cluster.Clunet.Console
{
    public partial class SelectKeyDialogForm : Form
    {
        public Keys Key { get; private set; }
        int escCount = 0;

        public SelectKeyDialogForm()
        {
            InitializeComponent();
        }

        private void SelectKeyDialog_KeyDown(object sender, KeyEventArgs e)
        {
            Key = e.KeyCode;
            labelKey.Text = e.KeyCode.ToString();

            if (e.KeyCode == Keys.Escape)
                escCount++;
            else escCount = 0;
            if (escCount >= 3)
            {
                Key = Keys.None;
                Close();
            }
        }
    }
}
